package com.mingrisoft.panel;

import static javax.swing.BorderFactory.createTitledBorder;

import javax.swing.JCheckBox;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableModel;

import com.mingrisoft.archives.InserStockFrame;
import com.mingrisoft.archives.UpdateDepotFrame;
import com.mingrisoft.archives.UpdateStockFrame;
import com.mingrisoft.bean.Stock;
import com.mingrisoft.dao.StockDao;
import com.mingrisoft.jbutton.ButtonEditor;
import com.mingrisoft.jbutton.ButtonRenderer;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileOutputStream;
import java.util.List;

import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;

public class JButtonTablePanel extends JPanel {
	private JTable table;
	 DefaultTableModel dm = new DefaultTableModel();
	 StockDao dao = new StockDao();
	 private JTextField conditionTextField;
	/**
	 * Create the panel.
	 */
	public JButtonTablePanel() {
		setLayout(null);
		this.setBorder(createTitledBorder(null, "ɹ",
                TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.TOP, new Font(
                        "sansserif", Font.BOLD, 12), new Color(59, 59, 59)));
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(43, 116, 520, 211);
		add(scrollPane);	
		dm.setDataVector(new Object[][]{{"","","","","","","",""}},
	                     new Object[]{"Ƿ","","ͻ","","","Ʒ","",""});	                     
		dm.removeRow(0);
		table = new JTable(dm);
		scrollPane.setViewportView(table);		 
		    List list = dao.selectStock();
		    for(int i = 0;i<list.size();i++){
		    	Stock stock = (Stock)list.get(i);
		    	String oid = stock.getOrderId();
		    	int id = dao.selectJoinStockByOid(oid);	    	
		    	if(id <=0){
		    		 dm.addRow(new Object[]{"",stock.getId(),stock.getsName(),stock.getOrderId(),stock.getConsignmentDate(),stock.getBaleName(),
		    				 stock.getMoney(),stock.getCount()});
		    		  File file = new File("files.txt");	    		  
		    		 try {	    				
		    				FileOutputStream out = new FileOutputStream(file);
		    				out.write(stock.getId());
		    				out.close();	    			
		    				repaint();			    				
		    			} catch (Exception ee) {
		    				ee.printStackTrace();
		    			}
		    	}
		    	else{
		    		 dm.addRow(new Object[]{"Ѿ",stock.getId(),stock.getsName(),stock.getOrderId(),stock.getConsignmentDate(),stock.getBaleName(),
		    				 stock.getMoney(),stock.getCount()});
		    	}
		    }	   
		    table.getColumn("Ƿ").setCellRenderer(new ButtonRenderer());	//ָеȾ
		    table.getColumn("Ƿ").setCellEditor(new ButtonEditor(new JCheckBox()));
		JButton insertButton = new JButton("");
		insertButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				InserStockFrame frame = new InserStockFrame();
				frame.setVisible(true);
			}
		});
		insertButton.setBounds(143, 353, 68, 23);
		add(insertButton);
		
JButton updateButton = new JButton("޸");
updateButton.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
		  int row = table.getSelectedRow();  			   //ȡûѡб
			if (row < 0) {	
				JOptionPane.showMessageDialog(getParent(), "ûѡҪ޸ĵݣ",
						"Ϣʾ", JOptionPane.INFORMATION_MESSAGE);
				return;
			} else {
				File file = new File("filedd.txt");			//ļ
				try {
					String column = dm.getValueAt(row, 1).toString();		//ȡе						
					file.createNewFile();					//½ļ
					FileOutputStream out = new FileOutputStream(file);
					out.write((Integer.parseInt(column)));					//дļ
					UpdateStockFrame frame = new UpdateStockFrame();		//޸Ϣ
					frame.setVisible(true);				
					out.close();							//ر		
					repaint();
				} catch (Exception ee) {
					ee.printStackTrace();
				}
			}
	}
});
		updateButton.setBounds(236, 353, 68, 23);
		add(updateButton);
		
JButton deleteButton = new JButton("ɾ");
deleteButton.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
		int row = table.getSelectedRow();  			//ȡûѡıк	   
		if (row < 0) {								//жûѡкǷ0
			JOptionPane.showMessageDialog(getParent(), "ûѡҪɾݣ",
					"Ϣʾ", JOptionPane.INFORMATION_MESSAGE);	
			return;									//˳
		}
		String column = dm.getValueAt(row, 1).toString();		//ȡûѡеĵһ	
		dao.deleteStock(Integer.parseInt(column));				//ɾݷ
		JOptionPane.showMessageDialog(getParent(), "ɾɹ",	
				"Ϣʾ", JOptionPane.INFORMATION_MESSAGE);		//ʾϢ
	}
});
		deleteButton.setBounds(337, 353, 68, 23);
		add(deleteButton);
		
		JLabel label = new JLabel("ѯ");
		label.setBounds(79, 72, 68, 15);
		add(label);
		String[] name = {"ͻ","",""};
		final JComboBox comboBox = new JComboBox(name);
		comboBox.setBounds(143, 66, 81, 21);
		add(comboBox);
		
		conditionTextField = new JTextField();
		conditionTextField.setBounds(252, 69, 145, 25);
		add(conditionTextField);
		conditionTextField.setColumns(10);
		
JButton findButton = new JButton("");
findButton.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
		dm.setRowCount(0);			//
		String condition = comboBox.getSelectedItem().toString();		//ȡûѡĲѯ
		String conditionText = conditionTextField.getText();			//ȡûӵĲѯ
		if(conditionText.equals("")){									//ûûӲѯ
			JOptionPane.showMessageDialog(getParent(), "ѯ",
					"Ϣʾ", JOptionPane.INFORMATION_MESSAGE);		//ʾϢ
			return;														//˳
		}
		if(condition.equals("Ʒ")){								//ûѡ񰴻Ʒƽ
		   List list = dao.selectStockBySName(conditionText);			//ðƷƲѯݷ
		   for(int i= 0;i<list.size();i++){								//ѭѯ
			   Stock stock = (Stock)list.get(i);
				String oid = stock.getOrderId();						//ȡϢ
		    	int id = dao.selectJoinStockByOid(oid);	    			//ݶŲѯϢ
		    	if(id <=0){												//öĻƷв
		    		 dm.addRow(new Object[]{"",stock.getId(),stock.getsName(),stock.getOrderId(),stock.getConsignmentDate(),stock.getBaleName(),
		    				 stock.getMoney(),stock.getCount()});		//
	 
		    	}
		    	else{													//ָŵĻƷд
		    		 dm.addRow(new Object[]{"Ѿ",stock.getId(),stock.getsName(),stock.getOrderId(),stock.getConsignmentDate(),stock.getBaleName(),
		    				 stock.getMoney(),stock.getCount()});
		    	}
		   }
		}
				if(condition.equals("")){
					   List list = dao.selectStockByOid(conditionText);
					    for(int i= 0;i<list.size();i++){
						   Stock stock = (Stock)list.get(i);
							String oid = stock.getOrderId();
					    	int id = dao.selectJoinStockByOid(oid);	    
					       	if(id <=0){
					    		 dm.addRow(new Object[]{"",stock.getId(),stock.getsName(),stock.getOrderId(),stock.getConsignmentDate(),stock.getBaleName(),
					    				 stock.getMoney(),stock.getCount()});
					    		  File file = new File("files.txt");	  
					    		 
					    	}
					    	else{
					    		 dm.addRow(new Object[]{"Ѿ",stock.getId(),stock.getsName(),stock.getOrderId(),stock.getConsignmentDate(),stock.getBaleName(),
					    				 stock.getMoney(),stock.getCount()});
					    	}
					   }
					}
				if(condition.equals("")){
					   List list = dao.selectStockByDate(conditionText);
					   for(int i= 0;i<list.size();i++){
						   Stock stock = (Stock)list.get(i);
							String oid = stock.getOrderId();
					    	int id = dao.selectJoinStockByOid(oid);	    	
					    	if(id <=0){
					    		 dm.addRow(new Object[]{"",stock.getId(),stock.getsName(),stock.getOrderId(),stock.getConsignmentDate(),stock.getBaleName(),
					    				 stock.getMoney(),stock.getCount()});
					    		  File file = new File("files.txt");	  
					    		 
					    	}
					    	else{
					    		 dm.addRow(new Object[]{"Ѿ",stock.getId(),stock.getsName(),stock.getOrderId(),stock.getConsignmentDate(),stock.getBaleName(),
					    				 stock.getMoney(),stock.getCount()});
					    	}
					   }
					}
			}
		});
		findButton.setBounds(407, 68, 68, 23);
		add(findButton);
		
	}
}
