package com.mingrisoft.widget;

import static javax.swing.BorderFactory.createEmptyBorder;
import java.awt.*;
import java.awt.event.*;
import java.io.Serializable;
import javax.swing.*;

/**
 * ƶ
 * 
 * @author 
 */
public class SmallScrollPanel extends BGPanel {
    private static final long serialVersionUID = 3592329256836525981L;
    private AlphaScrollPane alphaScrollPane;// 
    private JButton leftScrollButton = null;// ΢ť
    private JButton rightScrollButton = null;// Ҳ΢ť
    private ScrollMouseAdapter scrollMouseAdapter; // ¼
    private ImageIcon icon1;
    private ImageIcon icon2;
    
    /**
     * 췽
     */
public SmallScrollPanel() {
    scrollMouseAdapter = new ScrollMouseAdapter();// ʼ
    // ʼͼ
    icon1 = new ImageIcon(getClass().getResource("top01.png"));
    icon2 = new ImageIcon(getClass().getResource("top02.png"));
    setIcon(icon1);// ͼ
    setIconFill(BOTH_FILL);// ͼӦС
    initialize();// óʼ
}
    
    /**
     * ʼķ
     */
private void initialize() {
    BorderLayout borderLayout = new BorderLayout();
    borderLayout.setHgap(0);
    this.setLayout(borderLayout);// òֹ
    this.setSize(new Dimension(300, 84));
    this.setOpaque(false);// ʹؼ͸
    // ӹ嵽λ
    this.add(getAlphaScrollPanel(), BorderLayout.CENTER);
    // ΢ť
    this.add(getLeftScrollButton(), BorderLayout.WEST);
    // Ҳ΢ť
    this.add(getRightScrollButton(), BorderLayout.EAST);
}
    
    /**
     * 
     * 
     * @return
     */
    public AlphaScrollPane getAlphaScrollPanel() {
        if (alphaScrollPane == null) {
            alphaScrollPane = new AlphaScrollPane();
            // óʼС
            alphaScrollPane.setPreferredSize(new Dimension(564, 69));
            // ʾֱ
            alphaScrollPane
                    .setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
            // ʾˮƽ
            alphaScrollPane
                    .setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
            // ȡ߿
            alphaScrollPane.setBorderPaint(false);
            // ¼
            alphaScrollPane
                    .addComponentListener(new ScrollButtonShowListener());
        }
        return alphaScrollPane;
    }
    
    public void setViewportView(Component view) {
        alphaScrollPane.setViewportView(view);
    }
    
    /**
     * ΢
     * 
     * @author 
     */
    private class ScrollButtonShowListener extends ComponentAdapter implements
            Serializable {
        private static final long serialVersionUID = 814596372430146361L;
        
        @Override
        public void componentResized(ComponentEvent e) {
            // ȡ
            JScrollBar scrollBar = alphaScrollPane.getHorizontalScrollBar();
            // ȡΧƲ
            int scrollWidth = scrollBar.getMaximum();
            int paneWidth = alphaScrollPane.getWidth();
            // ڰݵʱ΢ť
            if (paneWidth >= scrollWidth) {
                getLeftScrollButton().setVisible(false);
                getRightScrollButton().setVisible(false);
            }
            // Сڰݵʱʾ΢ť
            if (paneWidth < scrollWidth) {
                getLeftScrollButton().setVisible(true);
                getRightScrollButton().setVisible(true);
            }
        }
    }
    
    /**
     * ΢ť
     * 
     * @return javax.swing.JButton
     */
private JButton getLeftScrollButton() {
    if (leftScrollButton == null) {
        leftScrollButton = new JButton();
        // ťͼ
        ImageIcon icon1 = new ImageIcon(getClass().getResource(
                "/com/mingrisoft/frame/buttonIcons/zuoyidongoff.png"));
        // ťͼ2
        ImageIcon icon2 = new ImageIcon(getClass().getResource(
                "/com/mingrisoft/frame/buttonIcons/zuoyidongon.png"));
        leftScrollButton.setOpaque(false);// ť͸
        // ñ߿
        leftScrollButton.setBorder(createEmptyBorder(0, 10, 0, 0));
        // ðťͼ
        leftScrollButton.setIcon(icon1);
        leftScrollButton.setPressedIcon(icon2);
        leftScrollButton.setRolloverIcon(icon2);
        // ȡť
        leftScrollButton.setContentAreaFilled(false);
        // óʼС
        leftScrollButton.setPreferredSize(new Dimension(38, 0));
        // ȡť㹦
        leftScrollButton.setFocusable(false);
        // ӹ¼
        leftScrollButton.addMouseListener(scrollMouseAdapter);
    }
    return leftScrollButton;
}
    
    /**
     * Ҳ΢ť
     * 
     * @return javax.swing.JButton
     */
    private JButton getRightScrollButton() {
        if (rightScrollButton == null) {
            rightScrollButton = new JButton();
            // ťͼ
            ImageIcon icon1 = new ImageIcon(getClass().getResource(
                    "/com/mingrisoft/frame/buttonIcons/youyidongoff.png"));
            // ťͼ2
            ImageIcon icon2 = new ImageIcon(getClass().getResource(
                    "/com/mingrisoft/frame/buttonIcons/youyidongon.png"));
            // ť͸
            rightScrollButton.setOpaque(false);
            // ñ߿
            rightScrollButton.setBorder(createEmptyBorder(0, 0, 0, 10));
            rightScrollButton.setIcon(icon1);// ðťͼ
            rightScrollButton.setPressedIcon(icon2);
            rightScrollButton.setRolloverIcon(icon2);
            // ȡťݻ
            rightScrollButton.setContentAreaFilled(false);
            // ðťʼС
            rightScrollButton.setPreferredSize(new Dimension(38, 92));
            // ȡť㹦
            rightScrollButton.setFocusable(false);
            // ӹ¼
            rightScrollButton.addMouseListener(scrollMouseAdapter);
        }
        return rightScrollButton;
    }
    
    /**
     * ΢ť¼
     * 
     * @author 
     */
private final class ScrollMouseAdapter extends MouseAdapter implements
        Serializable {
    private static final long serialVersionUID = 5589204752770150732L;
    // ȡˮƽ
    JScrollBar scrollBar = getAlphaScrollPanel().getHorizontalScrollBar();
    // ߳̿Ʊ
    private boolean isPressed = true;        
    public void mousePressed(MouseEvent e) {
        Object source = e.getSource();// ȡ¼Դ
        isPressed = true;
        // ж¼ԴఴťҲఴťִӦ
        if (source == getLeftScrollButton()) {
            scrollMoved(-1);
        } else {
            scrollMoved(1);
        }
    }        
    /**
     * ƶķ
     * @param orientation
     *            ƶ -1ƶ1һƶ
     */
    private void scrollMoved(final int orientation) {
        new Thread() {// µ߳
            // ԭйֵ
            private int oldValue = scrollBar.getValue();
            
            public void run() {
                while (isPressed) {// ѭƶ
                    try {
                        Thread.sleep(10);
                    } catch (InterruptedException e1) {
                        e1.printStackTrace();
                    }
                    // ȡǰֵ
                    oldValue = scrollBar.getValue();
                    EventQueue.invokeLater(new Runnable() {
                        public void run() {
                            // ùƶ3
                            scrollBar.setValue(oldValue + 3 * orientation);
                        }
                    });
                }
            }
        }.start();
    }        
    public void mouseExited(java.awt.event.MouseEvent e) {
        isPressed = false;
    }
    
    @Override
    public void mouseReleased(MouseEvent e) {
        isPressed = false;
    }
}
    
    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        // ͼƬ
        g.drawImage(icon2.getImage(), 0, 0, getWidth(), getHeight(), this);
    }
} // @jve:decl-index=0:visual-constraint="10,10"
