package com.mwq.frame.manage;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;

import com.mwq.dao.Dao;
import com.mwq.dao.JDBC;
import com.mwq.mwing.MTable;

public class SortDialog extends JDialog {

	private JTable table;

	private JTextField sortNameTextField;

	private final Vector columnNameV = new Vector();

	private final DefaultTableModel tableModel = new DefaultTableModel();

	private final Dao dao = Dao.getInstance();

	/**
	 * Launch the application
	 * 
	 * @param args
	 */
	public static void main(String args[]) {
		try {
			SortDialog dialog = new SortDialog();
			dialog.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog
	 */
	public SortDialog() {
		super();
		setModal(true);
		getContentPane().setLayout(new BorderLayout());
		setResizable(false);
		setTitle("ϵ");
		setBounds(100, 100, 500, 375);

		final JPanel operatePanel = new JPanel();
		getContentPane().add(operatePanel, BorderLayout.NORTH);

		final JLabel sortNameLabel = new JLabel();
		operatePanel.add(sortNameLabel);
		sortNameLabel.setText("ϵƣ");

		sortNameTextField = new JTextField();
		operatePanel.add(sortNameTextField);
		sortNameTextField.setColumns(20);

		final JLabel topPlaceholderLabel = new JLabel();
		topPlaceholderLabel.setPreferredSize(new Dimension(20, 40));
		operatePanel.add(topPlaceholderLabel);

		final JButton addButton = new JButton();// Ӳϵưť
		addButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String sortName = sortNameTextField.getText().trim(); // òϵƣȥβո
				if (sortName.equals("")) {// 鿴Ƿ˲ϵ
					JOptionPane.showMessageDialog(null, "ϵƣ", "ʾ",
							JOptionPane.INFORMATION_MESSAGE);
					return;
				}
				if (sortName.length() > 10) {// 鿴ϵƵĳǷ񳬹10
					JOptionPane.showMessageDialog(null, "ϵֻΪ10֣",
							"ʾ", JOptionPane.INFORMATION_MESSAGE);
					return;
				}
				if (dao.sSortByName(sortName).size() > 0) {// 鿴òϵǷѾ
					JOptionPane.showMessageDialog(null, "òϵѾڣ", "ʾ",
							JOptionPane.INFORMATION_MESSAGE);
					return;
				}
				int row = tableModel.getRowCount();// õǰӵвϵƵĸ
				Vector newSortV = new Vector();// һ²ϵƵ
				newSortV.add(new Integer(row + 1));// 
				newSortV.add(sortName);// Ӳϵ
				tableModel.addRow(newSortV);// ²ϵϢӵ
				table.setRowSelectionInterval(row, row);// ӵĲϵΪѡе
				sortNameTextField.setText(null);// ϵıΪ
				//
				dao.iSort(sortName);// ӵĲϵϢ浽ݿ
				JDBC.closeConnection();// رݿ
			}
		});
		addButton.setText("");
		operatePanel.add(addButton);

		final JButton delButton = new JButton();// ɾϵưť
		delButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int row = table.getSelectedRow();// ѡеĲϵ
				String delSortName = (String) table.getValueAt(row, 1);// ѡеĲϵ
				int j = JOptionPane
						.showConfirmDialog(null, "ȷҪɾϵ" + delSortName
								+ "", "ʾ", JOptionPane.YES_NO_OPTION);// ȷʾ
				if (j == 0) {// ȷɾ
					tableModel.removeRow(row);// ӱƳϵϢ
					int rowCount = table.getRowCount();// ɾӵеĲϵ
					if (rowCount > 0) {// ӵвϵ
						if (row < table.getRowCount()) {// ɾĲλڱĲϵ
							for (int i = row; i < table.getRowCount(); i++) {
								table.setValueAt(i + 1 + "", i, 0);// ޸λɾϵ֮
							}
							table.setRowSelectionInterval(row, row);// ƵɾĲϵΪѡ
						} else {// ɾλڱĲϵ
							table.setRowSelectionInterval(row - 1, row - 1);// õǰλڱĲϵѡ
						}
					}
					//
					dao.dSortByName(delSortName);// ݿɾϵ
					JDBC.closeConnection();// رݿ
				}
			}
		});
		delButton.setText("ɾ");
		operatePanel.add(delButton);

		final JScrollPane scrollPane = new JScrollPane();
		getContentPane().add(scrollPane);

		columnNameV.add("    ");
		columnNameV.add("ϵ");
		tableModel.setDataVector(dao.sSortName(), columnNameV);
		JDBC.closeConnection();

		table = new MTable(tableModel);
		if (table.getRowCount() > 0)
			table.setRowSelectionInterval(0, 0);
		scrollPane.setViewportView(table);

		final JLabel leftPlaceholderLabel = new JLabel();
		leftPlaceholderLabel.setPreferredSize(new Dimension(20, 20));
		getContentPane().add(leftPlaceholderLabel, BorderLayout.WEST);

		final JPanel exitPanel = new JPanel();
		final FlowLayout flowLayout = new FlowLayout();
		flowLayout.setAlignment(FlowLayout.RIGHT);
		exitPanel.setLayout(flowLayout);
		getContentPane().add(exitPanel, BorderLayout.SOUTH);

		final JButton exitButton = new JButton();
		exitPanel.add(exitButton);
		exitButton.setText("˳");
		exitButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		});

		final JLabel bottomPlaceholderLabel = new JLabel();
		bottomPlaceholderLabel.setPreferredSize(new Dimension(10, 40));
		exitPanel.add(bottomPlaceholderLabel);

		final JLabel rightPlaceholderLabel = new JLabel();
		rightPlaceholderLabel.setPreferredSize(new Dimension(20, 20));
		getContentPane().add(rightPlaceholderLabel, BorderLayout.EAST);
		//
	}
}
