package com.tarena.fly;

import java.awt.Font;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Arrays;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;
import java.awt.image.BufferedImage;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class ShootGame extends JPanel {
	public static final int WIDTH = 400; // 
	public static final int HEIGHT = 654; // 
	/** Ϸĵǰ״̬: START RUNNING PAUSE GAME_OVER */
	private int state;
	private static final int START = 0;
	private static final int RUNNING = 1;
	private static final int PAUSE = 2;
	private static final int GAME_OVER = 3;

	private int score = 0; // ÷
	private Timer timer; // ʱ
	private int intervel = 1000 / 100; // ʱ()

	public static BufferedImage background;
	public static BufferedImage start;
	public static BufferedImage airplane;
	public static BufferedImage bee;
	public static BufferedImage bullet;
	public static BufferedImage hero0;
	public static BufferedImage hero1;
	public static BufferedImage pause;
	public static BufferedImage gameover;
	public static BufferedImage boss;
	
    
	private FlyingObject[] flyings = {}; // л
	private Bullet[] bullets = {}; // ӵ
	private Hero hero = new Hero(); // Ӣۻ
	
	
	
    
	static { // ̬飬ʼͼƬԴ
		try {
			background = ImageIO.read(ShootGame.class
					.getResource("background.png"));
			start = ImageIO.read(ShootGame.class.getResource("start.png"));
			boss = ImageIO.read(ShootGame.class.getResource("boss.png"));
		
			airplane = ImageIO
					.read(ShootGame.class.getResource("airplane.png"));
			bee = ImageIO.read(ShootGame.class.getResource("bee.png"));
			bullet = ImageIO.read(ShootGame.class.getResource("bullet.png"));
			hero0 = ImageIO.read(ShootGame.class.getResource("hero0.png"));
			hero1 = ImageIO.read(ShootGame.class.getResource("hero1.png"));
			pause = ImageIO.read(ShootGame.class.getResource("pause.png"));
			gameover = ImageIO
					.read(ShootGame.class.getResource("gameover.png"));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**  */
	@Override
	public void paint(Graphics g) {
		g.drawImage(background, 0, 0, null); // ͼ
		paintHero(g); // Ӣۻ
		paintBullets(g); // ӵ
		paintFlyingObjects(g); // 
		paintScore(g); // 
		paintState(g); // Ϸ״̬
	
	}

	/** Ӣۻ */
	public void paintHero(Graphics g) {
		g.drawImage(hero.getImage(), hero.getX(), hero.getY(), null);
	}

	/** ӵ */
	public void paintBullets(Graphics g) {
		for (int i = 0; i < bullets.length; i++) {
			Bullet b = bullets[i];
			g.drawImage(b.getImage(), b.getX() - b.getWidth() / 2, b.getY(),
					null);
		}
	}

	/**  */
	public void paintFlyingObjects(Graphics g) {
		for (int i = 0; i < flyings.length; i++) {
			FlyingObject f = flyings[i];
			g.drawImage(f.getImage(), f.getX(), f.getY(), null);
		}
	}

	/**  */
	public void paintScore(Graphics g) {
		int x = 10; // x
		int y = 25; // y
		Font font = new Font(Font.SANS_SERIF, Font.BOLD, 14); // 
		g.setColor(new Color(0x3A3B3B));
		g.setFont(font); // 
		g.drawString("SCORE:" + score, x, y); // 
		y += 20; // y20
		g.drawString("LIFE:" + hero.getLife(), x, y); // 
	}

	/** Ϸ״̬ */
	public void paintState(Graphics g) {
		switch (state) {
		case START: // ״̬
			g.drawImage(start, 0, 0, null);
			break;
		case PAUSE: // ͣ״̬
			g.drawImage(pause, 0, 0, null);
			break;
		case GAME_OVER: // Ϸֹ״̬
			g.drawImage(gameover, 0, 0, null);
			break;
		}
	}

	public static void main(String[] args) {
		JFrame frame = new JFrame("Fly");
		ShootGame game = new ShootGame(); // 
		frame.add(game); // ӵJFrame
		frame.setSize(WIDTH, HEIGHT); // ôС
		frame.setAlwaysOnTop(true); // 
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); // ĬϹرղ
		frame.setIconImage(new ImageIcon("images/icon.jpg").getImage()); // ôͼ
		frame.setLocationRelativeTo(null); // ôʼλ
		frame.setVisible(true); // paint

		frame.setResizable(false);//̶ڲɵ
		game.action(); // ִ
	}

	/** ִд */
	public void action() {
		// ¼
		MouseAdapter l = new MouseAdapter() {
			@Override
			public void mouseMoved(MouseEvent e) { // ƶ
				if (state == RUNNING) { // ״̬ƶӢۻ--λ
					int x = e.getX();
					int y = e.getY();
					int x1 = e.getX();
					int y1 = e.getX();
				
					hero.moveTo(x, y);
					Bullet.moveTo(x1,y1);
					
					
				}
			}

			@Override
			public void mouseEntered(MouseEvent e) { // 
				if (state == PAUSE) { // ͣ״̬
					state = RUNNING;
				}
			}

			@Override
			public void mouseExited(MouseEvent e) { // ˳
				if (state != GAME_OVER) { // ϷδΪͣ
					state = PAUSE;
				}
			}

			@Override
			public void mouseClicked(MouseEvent e) { // 
				switch (state) {
				case START:
					state = RUNNING; // ״̬
					break;
				case GAME_OVER: // Ϸֳ
					flyings = new FlyingObject[0]; // շ
					bullets = new Bullet[0]; // ӵ
					hero = new Hero(); // ´Ӣۻ
					score = 0; // ճɼ
					state = START; // ״̬Ϊ
				
					break;
				}
			}
		};
		this.addMouseListener(l); // 
		this.addMouseMotionListener(l); // 껬

		timer = new Timer(); // ̿
		timer.schedule(new TimerTask() {
			@Override
			public void run() {
				if (state == RUNNING) { // ״̬
					enterAction(); // 볡
					stepAction(); // һ
					shootAction(); // Ӣۻ
					
				
					bangAction(); // ӵ
				
					outOfBoundsAction(); // ɾԽＰӵ
					checkGameOverAction(); // Ϸ
				}
				repaint(); // ػ棬paint()
			}

		}, intervel, intervel);
	}

	int flyEnteredIndex = 0; // 볡

	/** 볡 */
	public void enterAction() {
		flyEnteredIndex++;
		if (flyEnteredIndex % 40 == 0) { // 400һ--10*40
			FlyingObject obj = nextOne(); // һ
			flyings = Arrays.copyOf(flyings, flyings.length + 1);
			flyings[flyings.length - 1] = obj;
		}
	}

	/** һ */
	public void stepAction() {
		for (int i = 0; i < flyings.length; i++) { // һ
			FlyingObject f = flyings[i];
			f.step();
		}
		

		for (int i = 0; i < bullets.length; i++) { // ӵһ
			Bullet b = bullets[i];
			b.step();
			
			
			
		}
		
		hero.step(); // Ӣۻһ
	}

	/** һ */
	public void flyingStepAction() {
		for (int i = 0; i < flyings.length; i++) {
			FlyingObject f = flyings[i];
			f.step();
		}
	}

	int shootIndex = 0; // 

	/**  */
	public void shootAction() {
		shootIndex++;
		if (shootIndex % 25 == 0) { // 300뷢һ
			Bullet[] bs = hero.shoot(); // Ӣ۴ӵ
			bullets = Arrays.copyOf(bullets, bullets.length + bs.length); // 
			System.arraycopy(bs, 0, bullets, bullets.length - bs.length,
					bs.length); // ׷
		}
	}
	

	/** ӵײ */
	public void bangAction() {
		int index=-1;
		for (int i = 0; i < bullets.length; i++) { // ӵ
			Bullet b = bullets[i];
			
			if(bang(b)){
				index=i;
				break;
			}
		}
		if(index!=-1 ){
			Bullet b=bullets[index];
			bullets[index]=bullets[bullets.length-1];
			bullets[bullets.length-1]=b;
			bullets=Arrays.copyOf(bullets,bullets.length-1);
		}
	}
	

	/** ɾԽＰӵ */
	/*ɾɳڵ׶˵ĵ۷ͷɻ*/
	public void outOfBoundsAction() {
		int index = 0; // 
		FlyingObject[] flyingLives = new FlyingObject[flyings.length]; // ŵķ
		for (int i = 0; i < flyings.length; i++) {
			FlyingObject f = flyings[i];
			if (!f.outOfBounds()) {
				flyingLives[index++] = f; // Խ
			}
		}
		flyings = Arrays.copyOf(flyingLives, index); // Խķﶼ
		/*ɾɳڶ˵ĵӵ*/
		index = 0; // Ϊ0
		Bullet[] bulletLives = new Bullet[bullets.length];
		for (int i = 0; i < bullets.length; i++) {
			Bullet b = bullets[i];
			if (!b.outOfBounds()) {
				bulletLives[index++] = b;
			}
		}
		bullets = Arrays.copyOf(bulletLives, index); // Խӵ
		/*ɾɳߵĵӵ*/
		index = 0; // Ϊ0
		Bullet[] bulletLeftLives = new Bullet[bullets.length];
		for (int i = 0; i < bullets.length; i++) {
			Bullet b = bullets[i];
			if (!b.outOfBounds2()) {
				bulletLeftLives[index++] = b;
			}
		}
		bullets = Arrays.copyOf(bulletLeftLives, index);
		/*ɾɳұߵĵӵ*/
		index = 0; // Ϊ0
		Bullet[] bulletRightLives = new Bullet[bullets.length];
		for (int i = 0; i < bullets.length; i++) {
			Bullet b = bullets[i];
			if (!b.outOfBounds1()) {
				bulletRightLives[index++] = b;
			}
		}
		bullets = Arrays.copyOf(bulletRightLives, index);
	
	}

	/** Ϸ */
	public void checkGameOverAction() {
		if (isGameOver()) {
			state = GAME_OVER; // ı״̬
		}
	}

	/** ϷǷ */
	public boolean isGameOver() {

		for (int i = 0; i < flyings.length; i++) {
			int index = -1;
			FlyingObject obj = flyings[i];
			if (hero.hit(obj)) { // ӢۻǷײ
				hero.subtractLife(); // 
				hero.setDoubleFire(0); // ˫
				hero.setBigFire(0);
				index = i; // ¼ϵķ
			}
			if (index != -1) {
				FlyingObject t = flyings[index];
				flyings[index] = flyings[flyings.length - 1];
				flyings[flyings.length - 1] = t; // ϵһｻ

				flyings = Arrays.copyOf(flyings, flyings.length - 1); // ɾϵķ
			}
		}

		return hero.getLife() <= 0;
	}

	/** ӵͷ֮ײ */
	public boolean bang(Bullet bullet) {
		int index = -1; // еķ
		for (int i = 0; i < flyings.length; i++) {
			FlyingObject obj = flyings[i];
			if (obj.shootBy(bullet)) { // жǷ
				index = i; // ¼еķ
				break;
			}
		}
		if (index != -1) { // леķ
			FlyingObject one = flyings[index]; // ¼еķ

			if(one.life<=0){
			FlyingObject temp = flyings[index]; // еķһｻ
			flyings[index] = flyings[flyings.length - 1];
			flyings[flyings.length - 1] = temp;

			
			flyings = Arrays.copyOf(flyings, flyings.length - 1); 
			// ɾһ(е)
			}else{
				one.life--;
			}
			// one(˼ӷ֣ȡ)
			if (one instanceof Enemy) { // ͣǵˣӷ
				Enemy e = (Enemy) one;// ǿת
				if(one.life<=0){
				score += e.getScore(); // ӷ
				}
				
			if(one instanceof BigAward){
				BigAward b =(BigAward)one;
				if(one.life<=0){
					
			    score += e.getScore();
				int type = b.getAward();
				switch(type){
				case BigAward.BIG_FIRE:
					hero.addBigFire();break;}
				}
			}
			}else if (one instanceof Award) { // Ϊý
				Award a = (Award) one;
				int type = a.getType(); // ȡ
				switch (type) {
				case Award.DOUBLE_FIRE:
					hero.addDoubleFire(); // ˫
					break;
				case Award.LIFE:
					hero.addLife(); // ü
					break;
			
				}
				
				}
		return true;
		}
		return false;
	}
	
	/**
	 * ɷ
	 * 
	 * @return 
	 */
	public static FlyingObject nextOne() {
		Random random = new Random();
		int type = random.nextInt(20); // [0,20)
		if (type == 0) {
			return new Bee();
			
		}if(type==1){
			return new Boss();
		}
		else {
			return new Airplane();
		}
	}

}
